#include "armpsr.h"

/* $B3d$j9~$_%Y%/%?!'%j%;%C%H0J30$O(BRAM$B>e$N%Y%/%?$K%8%c%s%W$9$k(B */

	.section .vector,"ax"
	.arm
	.align 0
	.global	__reset
__reset:
	ldr	pc, =reset_entry
undef_vector:
	ldr	pc, =(_ramvector_start + 0x04)
swi_vector:
	ldr	pc, =(_ramvector_start + 0x08)
prefetch_abort_vector:
	ldr	pc, =(_ramvector_start + 0x0c)
data_abort_vector:
	ldr	pc, =(_ramvector_start + 0x10)
reserved_vector:
	ldr	pc, =(_ramvector_start + 0x14)
irq_vector:
	ldr	pc, =(_ramvector_start + 0x18)
fiq_vector:
	ldr	pc, =(_ramvector_start + 0x1c)

	.pool		/* ldr$BL?Na$G%m!<%I$9$kDj?t$O$3$3$KG[CV$9$k(B */


/* $B%9%?!<%H%"%C%W(B */

	.section .text
	.arm
	.align 0
	.global reset_entry

reset_entry:
	/* $B3F<o%9%?%C%/$r=i4|2=(B */
	msr	cpsr_fsxc, #(PSR_M_SYS | PSR_I | PSR_F)
	ldr	sp, =_sys_stack
	msr	cpsr_fsxc, #(PSR_M_UND | PSR_I | PSR_F)
	ldr	sp, =_und_stack
	msr	cpsr_fsxc, #(PSR_M_ABT | PSR_I | PSR_F)
	ldr	sp, =_abt_stack
	msr	cpsr_fsxc, #(PSR_M_FIQ | PSR_I | PSR_F)
	ldr	sp, =_fiq_stack
	msr	cpsr_fsxc, #(PSR_M_IRQ | PSR_I | PSR_F)
	ldr	sp, =_irq_stack
	msr	cpsr_fsxc, #(PSR_M_SVC | PSR_I | PSR_F)
	ldr	sp, =_svc_stack

	/* $B%\!<%I8GM-$N@_Dj(B */
	ldr	ip, =board_setup
	mov	r14, pc
	bx	ip

	/* .ramvector$B$N=i4|2=(B - ROM$B>e$N%Y%/%?$r%3%T!<$7$F$*$/(B */
ramvector_init:
	ldr	r1, =_romvector_start
	ldr	r2, =_ramvector_start
	ldr	r3, =_romvector_end
	cmp	r1, r3
	beq	data_init
ramvector_loop:
	ldr	r0, [r1], #4
	str	r0, [r2], #4
	cmp	r1, r3
	bne	ramvector_loop

	/* .data$B$N=i4|2=(B */
data_init:
	ldr	r1, = _data_org
	ldr	r2, = _data_start
	ldr	r3, = _data_end
	cmp	r2, r3
	beq	bss_init
data_loop:
	ldr	r0, [r1], #4
	str	r0, [r2], #4
	cmp	r2, r3
	bne	data_loop

	/* .bss$B$N=i4|2=(B */
bss_init:
	mov	r0, #0
	ldr	r2, =_bss_start
	ldr	r3, =_bss_end
	cmp	r2, r3
	beq	start_main
bss_loop:
	str	r0, [r2], #4
	cmp	r2, r3
	bne	bss_loop

	/* $B%a%$%s(B */
start_main:
	mov	r0, #0
	ldr	ip, =main
	mov	r14, pc
	bx	ip

	/* $BK=AvKI;_MQ$NL58B%k!<%W(B */
1:
	b	1b

	.pool
